<?php
/**
 * @copyright: Copyright © 2021 Firebear Studio. All rights reserved.
 * @author   : Firebear Studio <fbeardev@gmail.com>
 */

namespace Firebear\PlatformSap\Plugin;

use Firebear\PlatformSap\Model\Order\UpdatePublisher;
use Magento\Sales\Controller\Adminhtml\Order\Creditmemo\Save;

/**
 * Class CreditmemoUpdateAdminhtmlPlugin on CreditMemo Save action
 */
class CreditmemoUpdateAdminhtmlPlugin
{
    /**
     * @var UpdatePublisher
     */
    private $orderUpdatePublisher;

    /**
     * CreditmemoUpdateAdminhtmlPlugin constructor.
     * @param UpdatePublisher $orderUpdatePublisher
     */
    public function __construct(
        UpdatePublisher $orderUpdatePublisher
    ) {
        $this->orderUpdatePublisher = $orderUpdatePublisher;
    }

    /**
     * @param Save $subject
     * @param $result
     * @return mixed
     */
    public function afterExecute(
        Save $subject,
        $result
    ) {
        $orderId = $subject->getRequest()->getParam('order_id');
        $this->orderUpdatePublisher->execute($orderId);
        return $result;
    }
}
